// --8<--8<--8<--8<--
//
// Copyright (C) 2011 Smithsonian Astrophysical Observatory
//
// This file is part of bpmanip
//
// bpmanip is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// -->8-->8-->8-->8--

#include <iostream>
#include <algorithm>

#include <Wildmat.h>

using std::string;
using std::vector;

#include <wildmat/wildmat.h>

bool
Wildmat::operator== ( const string& text ) const {

    return wildmat( text.c_str(), pattern.c_str() );

}



bool
WildmatV::operator() ( const vector< Wildmat >& patterns, const string& text ) const {

    vector<Wildmat>::const_iterator found;

    found = find_if( patterns.begin(),
		  patterns.end(),
		  bind2nd( Wildmat(), text  ));

    return found != patterns.end();
}
