#include <string>
#include <iostream>

#include <lua.hpp>
#include <lauxlib.h>

#include "gtest/gtest.h"
#include "t_utils.h"

#include "lua_interface.h"
#include "common.h"

using namespace std;


class SystemTest : public testing::Test {

protected:

    lua_State *L;

    virtual void SetUp() {

	L = init_lua("", "");
    }

    virtual void TearDown() {

	cleanup_lua( L );

    }
};



TEST_F( SystemTest, logfile ) {


    int err;

    err = luaL_dostring( L, "system = require( 'saotrace.raygen.system' )" );
    ASSERT_EQ( 0, err ) << lua_tostring(L, -1 );

    sys.logfile = "big_fluffy_bunny";

    err = luaL_dostring( L, "return system.logfile()" );
    ASSERT_EQ( 0, err ) << lua_tostring(L, -1 );

    ASSERT_STREQ( "big_fluffy_bunny", lua_tostring(L, -1 ) );
}

