module( ..., package.seeall )

config = require( 'saotrace.config' )

setup = _G.setup

function test_proxy ()

   local test
   local ok, error = pcall( function () test = config.test end )
   assert_true( ok, error )

   assert_equal( 3, test.foo, "test.foo default" )

   local ok, error = pcall( function () test.foo = 9 end )
   assert_true( ok, error )
   assert_equal( 9, test.foo, "test.foo set/get" )

end

function test_multi_index ()

   assert_equal( 3, config.test.foo, "test.foo default" )
   config.test.foo = 1
   assert_equal( 1, config.test.foo, "test.foo set" )

end


function test_bad_proxy ()

   local ok, error = pcall( function () local foo = config.does_not_exist end )
   assert_false( ok, error )
   assert_match( 'error loading configuration', error )

end

function test_bad_set ()

   local ok, error = pcall( function () config.test.foo = -1 end )
   assert_false( ok, error )
   assert_match( 'did not match type', error )

end

function test_config_read_only ()

   local ok, error = pcall( function () config.snack = -1 end )
   assert_false( ok, error )
   assert_match( 'illegal assignment to saotrace.config.snack', error )

end


function test_global ()

   local ok, error = pcall( function () saotrace.config.test.foo = 99 end )
   assert_true( ok, error )
   assert_equal( 99, saotrace.config.test.foo )

end
