module( ..., package.seeall )

local os = require( 'os' )
local srcdir = os.getenv('srcdir') or '.'

local load_sources = require( 'saotrace.raygen.source.load' ).load_sources

function srcfile( name )

   return table.concat( { srcdir, 'data', name}, '/' )..'.xml'

end

function setup ()
   _G.setup()
   saotrace.raygen.intrinsic.stash = {}
end


function test_load_it( )

   local ok, msg = pcall( load_sources, srcfile('sources') )

   assert_true( ok, msg )

end

function test_load_bad1( )

   local ok, msg = pcall( load_sources, srcfile('bad1') )

   assert_false( ok, msg )
   assert_match( "only one position", msg )

end

function test_load_bad2( )

   local ok, msg = pcall( load_sources, srcfile('bad2') )

   assert_false( ok, msg )
   assert_match( "extent: required but not specified", msg )

end

function test_load_bad3( )

   local ok, msg = pcall( load_sources, srcfile('bad3') )

   assert_false( ok, msg )
   assert_match( "only one extent", msg )

end

function test_load_bad4( )

   local ok, msg = pcall( load_sources, srcfile('bad4') )

   assert_false( ok, msg )
   assert_match( "fluffy_bunny", msg )

end

function test_load_bad5( )

   local ok, msg = pcall( load_sources, srcfile('bad5') )

   assert_false( ok, msg )
   assert_match( "mangy_rabbit", msg )

end

