local table = require( 'table' )
local os = require( 'os' )
local srcdir = os.getenv('srcdir') or '.'
local require = require
module( ..., package.seeall )

require 'LuaXml'

local xml2table = require( 'saotrace.raygen.source.load' ).xml2table


function test_load( )

   local srcfile = table.concat( { srcdir, 'data', 'xml2table.xml'}, '/' )

   local doc = xml.load( srcfile )

   local tbl = xml2table(doc)

   assert_equal( "s1", tbl.source[1].name )

   assert_equal( 1.49, tbl.source[1].spectrum[1].energy )
   assert_equal( 2, tbl.source[1].spectrum[1].flux )

   assert_equal( "rdb", tbl.source[1].spectrum[2].format )

   assert_equal( "-60:38:51.66", tbl.source[2].position.dec )
   assert_equal( "7:58:50.661", tbl.source[2].position.ra )

   assert_equal( "-60:51:44.53", tbl.source[5].position.dec )
   assert_equal( 0.01, tbl.source[5].spectrum.scale )
end
