require('common' )
local tables = require('saotrace.suplib.tables' )

------------------------------------------------
-- shallow copy

b = { 1, 2 }
a = { x = 1, y = 2, z = b }


copy = tables.copy( a )

-- first make sure it looks ok
ok(         copy.x == 1
	and copy.y == 2
	and copy.z[1] == 1
	and copy.z[2] == 2,
     "shallow copy" )

-- now make sure that z really references b
b[1] = 3
ok( copy.z[1] == 3 , "shallow copy table ref" )



------------------------------------------------
-- "deep" copy

b = { 1, 2 }
a = { x = 1, y = 2, z = b }

copy = tables.copy( a, 1 )

-- first make sure it looks ok
ok(         copy.x == 1
	and copy.y == 2
	and copy.z[1] == 1
	and copy.z[2] == 2,
     "deep copy" )

-- now make sure that z really doesn't reference b
b[1] = 3
ok( copy.z[1] == 1 , "deep copy table ref" )


test_summary()
